//
//  QuestionDealWithView.m
//  redstar
//
//  Created by admin on 16/6/5.
//  Copyright © 2016年 ZWF. All rights reserved.
//

#import "QuestionDealWithView.h"
#import "SolvedTypeTableViewCell.h"
#import "FeedContentTableCell.h"

#import "HttpClient.h"
#import <MBProgressHUD.h>

#define kSolvedTypeTableViewCell @"solveTypeTableCell"
#define kFeedContentTableCell @"feedContentTableCell"

@interface QuestionDealWithView ()<UITableViewDelegate, UITableViewDataSource>
@property (nonatomic, strong) UIButton *selectButton;
@end

@implementation QuestionDealWithView
- (instancetype)init
{
    self = [super init];
    if (self) {
        [self setup];
    }
    return self;
}

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setup];
    }
    return self;
}


#pragma mark - Private Methods
- (void)setup
{
    self.titleLabel.text = @"问题处理";
    self.tableView.backgroundColor = [UIColor whiteColor];
    
    _selectButton = [[UIButton alloc] init];
    _selectButton.tag = 323118;
    
 //   [self requestGroupTitle];

}

// 请求问题专业组
//- (void)requestGroupTitle
//{
//    HttpClient *httpClient = [[HttpClient alloc] initWithUrl:[NSString stringWithFormat:@"%@%@", kRedStarURL, kQuestionGroupURL]];
//    [MBProgressHUD showHUDAddedTo:self animated:YES];
//    [httpClient getQuestionGroupWithCompletion:^(id response, NSError *error) {
//        NSDictionary *dataDict = response[@"data"];
//        NSArray *dataArray = dataDict[@"records"];
//        NSMutableDictionary *dict = [NSMutableDictionary dictionary];
//        NSMutableArray *nameArray = [NSMutableArray array];
//        for (NSDictionary *groupDict in dataArray) {
//            NSString *name = [NSString stringWithFormat:@"%@", groupDict[@"name"]];
//            NSString *groupUuid = [NSString stringWithFormat:@"%@", groupDict[@"uuid"]];
//            [dict setObject:groupUuid forKey:name];
//            [nameArray addObject:name];
//        }
//        _groupUuidDict = dict;
//        _categoryArray = nameArray;
//        _isComplete = YES;
//        
//        if (nameArray.count != 0) {
//            NSString *nameStr = [NSString stringWithFormat:@"%@", nameArray[0]];
//            [self requestCategoryWithGroupUuid:[dict objectForKey:nameStr]];
//        }
//        [MBProgressHUD hideAllHUDsForView:self animated:YES];
//        
//        [self.tableView reloadData];
//    }];
//}
//
//- (void)requestCategoryWithGroupUuid:(NSString *)groupUuid
//{
//    NSString *url = [NSString stringWithFormat:@"%@%@%@",kRedStarURL, kQuestionCategoryURL, groupUuid];
//    url = [url stringByAddingPercentEscapesUsingEncoding: NSUTF8StringEncoding];
//    HttpClient *http = [[HttpClient alloc] initWithUrl:url];
//    [MBProgressHUD showHUDAddedTo:self animated:YES];
//    [http getQuestionCategoryWithCompletion:^(id response, NSError *error) {
//        NSDictionary *dictData = response[@"data"];
//        NSArray *array = dictData[@"records"];
//        NSMutableArray *categoryArray = [NSMutableArray array];
//        for (NSDictionary *dict in array) {
//            NSString *category = [NSString stringWithFormat:@"%@", dict[@"name"]];
//            [categoryArray addObject:category];
//        }
//        _questionArray = categoryArray;
//        _isLoad = YES;
//        [MBProgressHUD hideAllHUDsForView:self animated:YES];
//        [self.tableView reloadData];
//    }];
//}


#pragma mark - lazy loading
- (UILabel *)titleLabel
{
    if (!_titleLabel) {
        _titleLabel = [[UILabel alloc] init];
        _titleLabel.userInteractionEnabled = YES;
        _titleLabel.font = [UIFont systemFontOfSize:18.0];
        _titleLabel.textColor = kLightBlack;
        _titleLabel.textAlignment = NSTextAlignmentCenter;
        _titleLabel.translatesAutoresizingMaskIntoConstraints = NO;
        _titleLabel.backgroundColor = kSectionBackGroundColor;
        [self addSubview:_titleLabel];
        
        // 顶端
        NSLayoutConstraint *titleTop = [NSLayoutConstraint constraintWithItem:_titleLabel attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeTop multiplier:1.0 constant:0];
        [self addConstraint:titleTop];
        
        // 左边
        NSLayoutConstraint *titleLeft = [NSLayoutConstraint constraintWithItem:_titleLabel attribute:NSLayoutAttributeLeft relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeLeft multiplier:1.0 constant:0];
        [self addConstraint:titleLeft];
        
        // 右边
        NSLayoutConstraint *titleRight = [NSLayoutConstraint constraintWithItem:_titleLabel attribute:NSLayoutAttributeRight relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeRight multiplier:1.0 constant:0];
        [self addConstraint:titleRight];
        
        // 右边
        NSLayoutConstraint *titleHeight = [NSLayoutConstraint constraintWithItem:_titleLabel attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1.0 constant:47];
        [self addConstraint:titleHeight];
        
    }
    return _titleLabel;
}

- (UIButton *)quitBtn
{
    if (!_quitBtn) {
        _quitBtn = [[UIButton alloc] init];
        _quitBtn.translatesAutoresizingMaskIntoConstraints = NO;
        [_quitBtn setImage:[UIImage imageNamed:@"close"] forState:UIControlStateNormal];
        [self addSubview:_quitBtn];
        [self insertSubview:_quitBtn aboveSubview:_titleLabel];
        
        // 顶端
        NSLayoutConstraint *titleTop = [NSLayoutConstraint constraintWithItem:_quitBtn attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeTop multiplier:1.0 constant:0];
        [self addConstraint:titleTop];
        
        // 左边
        NSLayoutConstraint *titleWidth = [NSLayoutConstraint constraintWithItem:_quitBtn attribute:NSLayoutAttributeWidth relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1.0 constant:47];
        [self addConstraint:titleWidth];
        
        // 右边
        NSLayoutConstraint *titleRight = [NSLayoutConstraint constraintWithItem:_quitBtn attribute:NSLayoutAttributeRight relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeRight multiplier:1.0 constant:0];
        [self addConstraint:titleRight];
        
        // 右边
        NSLayoutConstraint *titleHeight = [NSLayoutConstraint constraintWithItem:_quitBtn attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:nil attribute:NSLayoutAttributeNotAnAttribute multiplier:1.0 constant:47];
        [self addConstraint:titleHeight];
        
    }
    return _quitBtn;
}

- (UITableView *)tableView {
    if (!_tableView) {
        _tableView = [[UITableView alloc] init];
    }
    _tableView.delegate = self;
    _tableView.dataSource = self;
    _tableView.translatesAutoresizingMaskIntoConstraints = NO;

    [self addSubview:_tableView];
    
    // 顶端
    NSLayoutConstraint *titleTop = [NSLayoutConstraint constraintWithItem:_tableView attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.titleLabel attribute:NSLayoutAttributeBottom multiplier:1.0 constant:0];
    [self addConstraint:titleTop];
    
    // 左边
    NSLayoutConstraint *titleLeft = [NSLayoutConstraint constraintWithItem:_tableView attribute:NSLayoutAttributeLeft relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeLeft multiplier:1.0 constant:0];
    [self addConstraint:titleLeft];
    
    // 右边
    NSLayoutConstraint *titleRight = [NSLayoutConstraint constraintWithItem:_tableView attribute:NSLayoutAttributeRight relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeRight multiplier:1.0 constant:0];
    [self addConstraint:titleRight];
    
    // 右边
    NSLayoutConstraint *titleBottom = [NSLayoutConstraint constraintWithItem:_tableView attribute:NSLayoutAttributeBottom relatedBy:NSLayoutRelationEqual toItem:self attribute:NSLayoutAttributeBottom multiplier:1.0 constant:0];
    [self addConstraint:titleBottom];
    
    return _tableView;
}


#pragma mark - UITableView Delegate/DataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 4;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.row < 2) {
        UITableViewCell *cell=[tableView dequeueReusableCellWithIdentifier:@"groupAndCategaryCell"];
        if (!cell) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"groupAndCategaryCell"];
        }
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.textLabel.font = [UIFont systemFontOfSize:17.0];
        cell.textLabel.textColor = kdetailCellTitleColor;
        if (indexPath.row == 0) {
            cell.textLabel.text = @"专业组";
        } else {
            cell.textLabel.text = @"问题分类";
        }
        
        return cell;
    } else if (indexPath.row == 2) {
        SolvedTypeTableViewCell *cell=[tableView dequeueReusableCellWithIdentifier:kSolvedTypeTableViewCell];
        if (!cell) {
            cell = [[SolvedTypeTableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:kSolvedTypeTableViewCell];
        }
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.titleLabel.text = @"解决办法";
        [cell.quesBtn addTarget:self action:@selector(solveQues:) forControlEvents:UIControlEventTouchUpInside];
        [cell.FAQBtn addTarget:self action:@selector(solveQues:) forControlEvents:UIControlEventTouchUpInside];
        [cell.SOPBtn addTarget:self action:@selector(solveQues:) forControlEvents:UIControlEventTouchUpInside];
        return cell;
    } else {
        FeedContentTableCell *cell=[tableView dequeueReusableCellWithIdentifier:kFeedContentTableCell];
        if (!cell) {
            cell = [[FeedContentTableCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:kFeedContentTableCell];
        }
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.titleLabel.text = @"反馈信息";
        UIImage *image = [UIImage imageNamed:@"textbox"];
        UIImage *resizingName = [image resizableImageWithCapInsets:UIEdgeInsetsMake(1, 1, 24, 24) resizingMode:UIImageResizingModeStretch];
        cell.backImageView1.image = resizingName;
        cell.titleTextView.backgroundColor = [UIColor clearColor];
        cell.placeholderLabel1.text = @"请输入反馈内容...";

        [cell.changeBtn addTarget:self action:@selector(changeClick:) forControlEvents:UIControlEventTouchUpInside];
        [cell.solveBtn addTarget:self action:@selector(solveClick:) forControlEvents:UIControlEventTouchUpInside];

        return cell;
    }
    
    
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    if ([_delegate respondsToSelector:@selector(tableDidSelectAtIndexPath:)]) {
        [_delegate tableDidSelectAtIndexPath:indexPath];
    }
}

- (void)solveQues:(UIButton *)sender {
    _selectButton.selected = NO;
    sender.selected = YES;
    _selectButton = (UIButton *)sender;
    [self.tableView reloadData];

}

- (void)changeClick:(UIButton *)sender {
    
}


- (void)solveClick:(UIButton *)sender {
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (indexPath.row < 2) {
        return 50;
    } else if (indexPath.row == 2) {
        return 88;
    } else {
        return 218;
    }
}
// section高度
- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    return CGFLOAT_MIN;
}

- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section
{
    return CGFLOAT_MIN;
}



@end
